src/Entity/User.php
<?php

declare(strict_types=1);

namespace Buddy\Repman\Entity;

use Buddy\Repman\Entity\Organization\Member;
use Buddy\Repman\Entity\User\ApiToken;
use Buddy\Repman\Entity\User\OAuthToken;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Ramsey\Uuid\Uuid;
use Ramsey\Uuid\UuidInterface;

/**
 * @ORM\Entity(repositoryClass="Buddy\Repman\Repository\UserRepository")
 * @ORM\Table(name="`user`")
 */
class User
{
    const STATUS_ENABLED = 'enabled';

    const STATUS_DISABLED = 'disabled';

    /**
     * @ORM\Id
     * @ORM\Column(type="uuid", unique=true)
     */
    private UuidInterface $id;

    /**
     * @ORM\Column(type="string", length=180, unique=true)
     */
    private string $email;

    /**
     * @ORM\Column(type="datetime_immutable")
     */
    private \DateTimeImmutable $createdAt;

    /**
     * @var array<string>
     * @ORM\Column(type="json")
     */
    private array $roles = [];

    /**
     * @var string The hashed password
     * @ORM\Column(type="string")
     */
    private string $password;

    /**
     * @ORM\Column(type="datetime_immutable", nullable=true)
     */
    private ?\DateTimeImmutable $emailConfirmedAt = null;

    /**
     * @ORM\Column(type="string", unique=true)
     */
    private string $emailConfirmToken;

    /**
     * @ORM\Column(type="string", nullable=true, unique=true)
     */
    private ?string $resetPasswordToken = null;

    /**
     * @ORM\Column(type="datetime_immutable", nullable=true)
     */
    private ?\DateTimeImmutable $resetPasswordTokenCreatedAt = null;

    /**
     * @var Collection<int,Member>|Member[]
     * @ORM\OneToMany(targetEntity="Buddy\Repman\Entity\Organization\Member", mappedBy="user", orphanRemoval=true)
     */
    private Collection $memberships;

    /**
     * @ORM\Column(type="string", length=20)
     */
    private string $status = self::STATUS_ENABLED;

    /**
     * @var Collection<int,OAuthToken>|OAuthToken[]
     * @ORM\OneToMany(targetEntity="Buddy\Repman\Entity\User\OAuthToken", mappedBy="user", orphanRemoval=true, cascade={"persist"})
     */
    private Collection $oauthTokens;

    /**
     * @ORM\Column(type="boolean")
     */
    private bool $emailScanResult = true;

    /**
     * @var Collection<int,ApiToken>|ApiToken[]
     * @ORM\OneToMany(targetEntity="Buddy\Repman\Entity\User\ApiToken", mappedBy="user", cascade={"persist"}, orphanRemoval=true)
     */
    private Collection $apiTokens;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private string $timezone;

    /**
     * @param array<string> $roles
     */
    public function __construct(UuidInterface $id, string $email, string $emailConfirmToken, array $roles, ?string $timezone = null)
    {
        $this->id = $id;
        $this->email = \mb_strtolower($email);
        $this->emailConfirmToken = $emailConfirmToken;
        $this->roles = array_values(array_unique($roles));
        $this->timezone = $timezone ?? date_default_timezone_get();
        $this->createdAt = new \DateTimeImmutable();
        $this->memberships = new ArrayCollection();
        $this->oauthTokens = new ArrayCollection();
        $this->apiTokens = new ArrayCollection();
    }

    public function setResetPasswordToken(string $token): void
    {
        $this->resetPasswordToken = $token;
        $this->resetPasswordTokenCreatedAt = new \DateTimeImmutable();
    }

    public function resetPassword(string $token, string $password, int $tokenTtl): void
    {
        if ($token !== $this->resetPasswordToken) {
            throw new \InvalidArgumentException('Invalid reset password token');
        }

        if ($this->resetPasswordTokenCreatedAt === null || $this->resetPasswordTokenCreatedAt->modify(sprintf('%s sec', $tokenTtl)) < new \DateTimeImmutable()) {
            throw new \InvalidArgumentException('Token expired');
        }

        $this->password = $password;
        $this->resetPasswordToken = null;
        $this->resetPasswordTokenCreatedAt = null;
    }

    public function confirmEmail(string $token): void
    {
        if ($this->emailConfirmedAt !== null) {
            return;
        }

        if ($token !== $this->emailConfirmToken) {
            throw new \InvalidArgumentException('Invalid confirm e-mail token');
        }

        $this->emailConfirmedAt = new \DateTimeImmutable();
    }

    public function emailConfirmedAt(): ?\DateTimeImmutable
    {
        return $this->emailConfirmedAt;
    }

    public function id(): UuidInterface
    {
        return $this->id;
    }

    public function getEmail(): string
    {
        return $this->email;
    }

    /**
     * @param string[] $roles
     */
    public function changeRoles(array $roles): void
    {
        $this->roles = array_values(array_unique($roles));
    }

    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): void
    {
        $this->password = $password;
    }

    /**
     * @return Collection<int,Organization>|Organization[]
     */
    public function getOrganizations(): Collection
    {
        return $this->memberships->map(fn (Member $member) => $member->organization());
    }

    public function disable(): void
    {
        $this->status = self::STATUS_DISABLED;
    }

    public function enable(): void
    {
        $this->status = self::STATUS_ENABLED;
    }

    public function changePassword(string $password): void
    {
        $this->password = $password;
    }

    public function addOAuthToken(OAuthToken $oauthToken): self
    {
        if (!$this->oauthTokens->contains($oauthToken)) {
            $this->oauthTokens[] = $oauthToken;
        }

        return $this;
    }

    public function oauthToken(string $type): ?OAuthToken
    {
        foreach ($this->oauthTokens as $token) {
            if ($token->isType($type)) {
                return $token;
            }
        }

        return null;
    }

    public function removeOAuthToken(string $type): void
    {
        foreach ($this->oauthTokens as $oauthToken) {
            if ($oauthToken->isType($type)) {
                $this->oauthTokens->removeElement($oauthToken);
            }
        }
    }

    public function addMembership(Member $member): void
    {
        if (!$this->memberships->filter(fn (Member $m) => $m->userId()->equals($member->userId()))->isEmpty()) {
            return;
        }

        $this->memberships->add($member);
    }

    public function emailScanResult(): bool
    {
        return $this->emailScanResult;
    }

    public function hasEmailConfirmed(): bool
    {
        return $this->emailConfirmedAt !== null;
    }

    public function setEmailScanResult(bool $emailScanResult): void
    {
        $this->emailScanResult = $emailScanResult;
    }

    public function addApiToken(ApiToken $token): void
    {
        $token->setUser($this);
        $this->apiTokens->add($token);
    }

    public function regenerateApiToken(string $value, string $newValue): void
    {
        foreach ($this->apiTokens as $token) {
            if ($token->isEqual($value)) {
                $token->regenerate($newValue);
            }
        }
    }

    public function removeApiToken(string $value): void
    {
        foreach ($this->apiTokens as $token) {
            if ($token->isEqual($value)) {
                $this->apiTokens->removeElement($token);
            }
        }
    }

    public function changeTimezone(string $timezone): void
    {
        $this->timezone = $timezone;
    }
}

templates/base-card.html.twig
{% extends 'base.html.twig' %}

{% block title %}Log in! - Repman{% endblock %}

{% block body %}
    <body class="antialiased border-top-wide border-primary">
    <div class="d-flex h-auto min-h-full justify-content-center">
        <div class="d-flex align-items-center justify-content-center flex-fill">
            <div class="container">
                <div class="row">
                    <div class="col col-login mx-auto">
                        <div class="text-center mb-4">
                            <a href="{{ url('index') }}">
                                <img src="{{ asset('repman-vertical.svg') }}" style="height: 10rem;" alt="Repman - PHP Repository manager" />
                            </a>
                        </div>
                        {% block card %}{% endblock %}
                    </div>
                </div>
            </div>
        </div>
    </div>
    </body>
{% endblock %}

templates/base.html.twig
{% set current_route = app.request.get('_route') %}
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, viewport-fit=cover"/>
    <meta http-equiv="X-UA-Compatible" content="ie=edge"/>
    <meta http-equiv="Content-Language" content="en"/>
    <meta name="msapplication-TileColor" content="#206bc4"/>
    <meta name="theme-color" content="#206bc4"/>
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent"/>
    <meta name="apple-mobile-web-app-capable" content="yes"/>
    <meta name="mobile-web-app-capable" content="yes"/>
    <meta name="HandheldFriendly" content="True"/>
    <meta name="MobileOptimized" content="320"/>

    <link rel="icon" href="{{ asset('favicon.ico') }}" type="image/x-icon"/>
    <link rel="shortcut icon" href="{{ asset('favicon.ico') }}" type="image/x-icon"/>
    <title>{% block title %}Repman - PHP Repository Manager{% endblock %}</title>
    {% block stylesheets %}
        <link rel="stylesheet" href="{{ asset('dist/css/tabler.min.css') }}">
        <link rel="stylesheet" href="{{ asset('dist/css/dashboard.css') }}">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/css/bootstrap-select.min.css">
    {% endblock %}
</head>
<body class="antialiased">
    {% block body %}
    <div class="wrapper">
        <div class="content">
            <header class="topnav">
                <div class="container">
                    <div class="navbar navbar-expand-lg navbar-light">
                        <a href="{{ path('index') }}" class="logo">
                            <img src="{{ asset('repman-horizontal.svg') }}" style="height: 3rem;" alt="Repman - PHP Repository manager" />
                        </a>
                        {% block user %}
                            {% include 'component/user.html.twig' %}
                        {% endblock %}
                    </div>
                </div>
            </header>
            {% block menu %}
            <header class="topnav">
                <div class="navbar navbar-expand-lg navbar-light">
                    <div class="container">
                        <ul class="navbar-nav flex-wrap">
                            {% if organization is defined %}
                                <li class="nav-item">
                                    <a class="nav-link {{ current_route == 'organization_overview' ? 'active' : '' }}" href="{{ path('organization_overview', {"organization":organization.alias}) }}">
                                        <span class="nav-icon">{% include 'svg/home.svg' %}</span>
                                        <span class="d-none d-sm-block">Overview</span>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link {{ current_route == 'organization_packages' ? 'active' : '' }}" href="{{ path('organization_packages', {"organization":organization.alias}) }}">
                                        <span class="nav-icon">{% include 'svg/package.svg' %}</span>
                                        <span class="d-none d-sm-block">Packages</span>
                                    </a>
                                </li>
                                {% if is_granted('ROLE_ORGANIZATION_MEMBER', organization) %}
                                    <li class="nav-item">
                                        <a class="nav-link {{ current_route == 'organization_tokens' ? 'active' : '' }}" href="{{ path('organization_tokens', {"organization":organization.alias}) }}">
                                            <span class="nav-icon">{% include 'svg/lock.svg' %}</span>
                                            <span class="d-none d-sm-block">Tokens</span>
                                        </a>
                                    </li>
                                    <li class="nav-item">
                                        <a class="nav-link {{ current_route == 'organization_members' ? 'active' : '' }}" href="{{ path('organization_members', {"organization":organization.alias}) }}">
                                            <span class="nav-icon">{% include 'svg/users.svg' %}</span>
                                            <span class="d-none d-sm-block">Members</span>
                                        </a>
                                    </li>
                                {% endif %}
                                {% if is_granted('ROLE_ORGANIZATION_OWNER', organization) %}
                                    <li class="nav-item">
                                        <a class="nav-link {{ current_route == 'organization_settings' ? 'active' : '' }}" href="{{ path('organization_settings', {"organization":organization.alias}) }}">
                                            <span class="nav-icon">{% include 'svg/sliders.svg' %}</span>
                                            <span class="d-none d-sm-block">Settings</span>
                                        </a>
                                    </li>
                                {% endif %}
                            {% else %}
                                <li class="nav-item">
                                    <a class="nav-link {{ current_route == 'index' ? 'active' : '' }}" href="{{ path('index') }}">
                                        <span class="nav-icon">{% include 'svg/home.svg' %}</span>
                                        <span class="d-none d-sm-block">Home</span>
                                    </a>
                                </li>
                            {% endif %}
                        </ul>
                    </div>
                </div>
            </header>
            {% endblock menu %}
            {% block page %}
            <div class="content-page">
                <main class="container my-4 flex-fill">
                    <div class="row justify-content-center">
                        <div class="col-lg-12">

                            {% include 'component/flash.html.twig' %}

                            <div class="card">
                                {% if block('header') is defined %}
                                    <div class="card-header">
                                        <h3 class="card-title flex-grow-1">
                                            {% block header %}{% endblock %}
                                        </h3>
                                        <div class="d-flex">
                                            {% block header_btn %}{% endblock %}
                                        </div>
                                    </div>
                                {% endif %}
                                <div class="card-body">
                                    {% block content %}{% endblock %}
                                </div>
                            </div>
                        </div>
                    </div>
                </main>
            </div>
            {% endblock page %}
        </div>
    </div>
    {% endblock body %}
    {% include 'component/confirmationModal.html.twig' %}

    <script src="https://code.jquery.com/jquery-3.5.1.min.js" integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.13.18/js/bootstrap-select.min.js" integrity="sha512-yDlE7vpGDP7o2eftkCiPZ+yuUyEcaBwoJoIhdXv71KZWugFqEphIS3PU60lEkFaz8RxaVsMpSvQxMBaKVwA5xg==" crossorigin="anonymous"></script>

    {% if ga_tracking is not empty %}
        <script async src='https://www.google-analytics.com/analytics.js'></script>
        <script>{% include 'component/js/ga.js' %}</script>
    {% endif %}

    {% if ga4_tracking is not empty %}
        <script async src="https://www.googletagmanager.com/gtag/js?id={{ ga4_tracking }}"></script>
        <script>{% include 'component/js/ga4.js' %}</script>
    {% endif %}

    <script>{% include 'component/js/base.js' %}</script>
    {% block javascripts %}{% endblock %}
</body>
</html>

templates/index.html.twig
{% extends "base.html.twig" %}

{% block page %}
<div class="content-page">
    <main class="container my-4 flex-fill">
        {% include 'component/flash.html.twig' %}

        {% if is_granted('ROLE_ADMIN') and showTelemetryPrompt %}
            {% include 'component/telemetryPrompt.html.twig' %}
        {% endif %}

        <div class="row justify-content-center">
            <div class="col-lg-6">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title flex-grow-1">Proxy</h3>
                    </div>
                    <div class="card-body">
                        <p>
                            Repman works as a proxy for packagist.org, speeding up your local builds. To speed up your build, use this Composer plugin:
                        </p>
                        <div class="highlight">
                            <pre>composer global require repman-io/composer-plugin</pre>
                        </div>

                        <p>You can also add these lines to your composer.json file:</p>

                        <div class="highlight">
<pre>
{
    "repositories": [
        {"type": "composer", "url": "{{ url('proxy_repo_url') | trim('/') }}"},
        {"packagist": false}
    ]
}
</pre>
                        </div>
                        <p>The last step is updating composer.lock:</p>
                        <div class="highlight">
                            <pre>composer update --lock</pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title flex-grow-1">Organizations</h3>
                    </div>
                    <div class="card-body">
                        <p>
                            Organizations allow you to manage your private packages and the access to them.
                        </p>
                        {% if not app.user.belongsToAnyOrganization %}
                            <a href="{{ path('organization_create') }}" class="btn btn-green">Create a new organization</a>
                        {% else %}
                            <ul>
                            {% for org in app.user.organizations %}
                                <li><a href="{{ url('organization_overview', {"organization": org.alias}) }}">
                                    {{ org.name }}
                                </a></li>
                            {% endfor %}
                            </ul>
                            <p>
                                <a href="{{ path('organization_create') }}">Create a new organization</a>
                            </p>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </main>
</div>
{% endblock page %}